"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.ItemLabel = exports.ItemButtonWrapper = exports.ItemWrapper = exports.ItemContainer = exports.useDefaultAction = void 0;
const react_1 = __importStar(require("react"));
const compass_components_1 = require("@mongodb-js/compass-components");
function useDefaultAction(onDefaultAction) {
    const onClick = (0, react_1.useCallback)((evt) => {
        evt.stopPropagation();
        onDefaultAction(evt);
    }, [onDefaultAction]);
    const onKeyDown = (0, react_1.useCallback)((evt) => {
        if (evt.target === evt.currentTarget &&
            [' ', 'Enter'].includes(evt.key)) {
            evt.preventDefault();
            evt.stopPropagation();
            onDefaultAction(evt);
        }
    }, [onDefaultAction]);
    return { onClick, onKeyDown };
}
exports.useDefaultAction = useDefaultAction;
const itemContainer = (0, compass_components_1.css)({
    cursor: 'pointer',
    color: 'var(--item-color)',
    '& .item-action-controls': {
        marginLeft: 'auto',
        marginRight: compass_components_1.spacing[1],
    },
    '&:hover .item-background': {
        display: 'block',
        backgroundColor: 'var(--item-bg-color-hover)',
    },
    '& .item-action-controls:hover + .item-background': {
        display: 'none',
    },
    svg: {
        flexShrink: 0,
    },
});
const activeItemContainer = (0, compass_components_1.css)({
    color: 'var(--item-color-active)',
    fontWeight: 'bold',
    '.item-background, :hover .item-background': {
        backgroundColor: 'var(--item-bg-color-active)',
    },
    '::before': {
        zIndex: 1,
        backgroundColor: 'var(--item-color-active)',
        content: '""',
        position: 'absolute',
        left: '0px',
        top: '6px',
        bottom: '6px',
        width: '4px',
        borderRadius: '0px 6px 6px 0px',
    },
});
const itemWrapper = (0, compass_components_1.css)({
    position: 'relative',
    display: 'flex',
    alignItems: 'center',
});
const itemBackground = (0, compass_components_1.css)({
    position: 'absolute',
    top: 0,
    left: 0,
    width: '100%',
    height: '100%',
    zIndex: -1,
});
const itemButtonWrapper = (0, compass_components_1.css)({
    display: 'flex',
    alignItems: 'center',
    minWidth: 0,
});
const itemLabel = (0, compass_components_1.css)({
    overflow: 'hidden',
    whiteSpace: 'nowrap',
    textOverflow: 'ellipsis',
});
const ItemContainer = ({ id, level, setSize, posInSet, isExpanded, isActive, isTabbable, onDefaultAction, children, className, ...props }) => {
    const focusRingProps = (0, compass_components_1.useFocusRing)();
    const defaultActionProps = useDefaultAction(onDefaultAction);
    const extraCSS = [];
    if (isActive) {
        extraCSS.push(activeItemContainer);
    }
    const treeItemProps = (0, compass_components_1.mergeProps)({
        role: 'treeitem',
        'aria-level': level,
        'aria-setsize': setSize,
        'aria-posinset': posInSet,
        'aria-expanded': isExpanded,
        tabIndex: isTabbable ? 0 : -1,
        className: (0, compass_components_1.cx)(itemContainer, ...extraCSS, className),
    }, props, defaultActionProps, focusRingProps);
    return (react_1.default.createElement("div", { "data-id": id, "data-testid": `sidebar-database-${id}`, ...treeItemProps }, children));
};
exports.ItemContainer = ItemContainer;
const ItemWrapper = ({ className, children }) => {
    return (react_1.default.createElement("div", { className: (0, compass_components_1.cx)(itemWrapper, className) },
        children,
        react_1.default.createElement("div", { className: (0, compass_components_1.cx)('item-background', itemBackground) })));
};
exports.ItemWrapper = ItemWrapper;
const ItemButtonWrapper = ({ className, children }) => {
    return react_1.default.createElement("div", { className: (0, compass_components_1.cx)(itemButtonWrapper, className) }, children);
};
exports.ItemButtonWrapper = ItemButtonWrapper;
const ItemLabel = ({ children, className, ...props }) => {
    return (react_1.default.createElement("span", { className: (0, compass_components_1.cx)(itemLabel, className), ...props }, children));
};
exports.ItemLabel = ItemLabel;
//# sourceMappingURL=tree-item.js.map